Index: kernel/arch/arm32/src/userspace.c
===================================================================
--- kernel/arch/arm32/src/userspace.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/arm32/src/userspace.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -35,5 +35,4 @@
 
 #include <userspace.h>
-#include <arch/ras.h>
 
 /** Struct for holding all general purpose registers.
@@ -75,11 +74,8 @@
 	ustate.r1 = 0;
 
-	/* pass the RAS page address in %r2 */
-	ustate.r2 = (uintptr_t) ras_page;
-
 	/* clear other registers */
-	ustate.r3  = ustate.r4  = ustate.r5 = ustate.r6 = ustate.r7 =
-	    ustate.r8 = ustate.r9 = ustate.r10 = ustate.r11 = ustate.r12 =
-	    ustate.lr = 0;
+	ustate.r2 = ustate.r3  = ustate.r4  = ustate.r5 =
+	    ustate.r6  = ustate.r7  = ustate.r8  = ustate.r9 = ustate.r10 = 
+	    ustate.r11 = ustate.r12 = ustate.lr = 0;
 
 	/* set user stack */
Index: kernel/arch/ia32/include/mm/page.h
===================================================================
--- kernel/arch/ia32/include/mm/page.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/ia32/include/mm/page.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -146,21 +146,5 @@
 #define PFERR_CODE_RSVD		(1 << 3)	
 
-/** Page Table Entry. */
-typedef struct {
-	unsigned present : 1;
-	unsigned writeable : 1;
-	unsigned uaccessible : 1;
-	unsigned page_write_through : 1;
-	unsigned page_cache_disable : 1;
-	unsigned accessed : 1;
-	unsigned dirty : 1;
-	unsigned pat : 1;
-	unsigned global : 1;
-	unsigned soft_valid : 1;	/**< Valid content even if the present bit is not set. */
-	unsigned avl : 2;
-	unsigned frame_address : 20;
-} __attribute__ ((packed)) pte_t;
-
-static inline unsigned int get_pt_flags(pte_t *pt, size_t i)
+static inline int get_pt_flags(pte_t *pt, size_t i)
 {
 	pte_t *p = &pt[i];
Index: kernel/arch/ia32/include/types.h
===================================================================
--- kernel/arch/ia32/include/types.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/ia32/include/types.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -80,4 +80,20 @@
 #define PRIxn "x"	/**< Format for hexadecimal (u)native_t. */
 
+/** Page Table Entry. */
+typedef struct {
+	unsigned present : 1;
+	unsigned writeable : 1;
+	unsigned uaccessible : 1;
+	unsigned page_write_through : 1;
+	unsigned page_cache_disable : 1;
+	unsigned accessed : 1;
+	unsigned dirty : 1;
+	unsigned pat : 1;
+	unsigned global : 1;
+	unsigned soft_valid : 1;	/**< Valid content even if the present bit is not set. */
+	unsigned avl : 2;
+	unsigned frame_address : 20;
+} __attribute__ ((packed)) pte_t;
+
 #endif
 
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/ia32/src/ia32.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -68,5 +68,4 @@
 #include <sysinfo/sysinfo.h>
 #include <arch/boot/boot.h>
-#include <memstr.h>
 
 #ifdef CONFIG_SMP
Index: kernel/arch/ia32/src/interrupt.c
===================================================================
--- kernel/arch/ia32/src/interrupt.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/ia32/src/interrupt.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -98,12 +98,4 @@
 }
 
-static void de_fault(int n, istate_t *istate)
-{
-	fault_if_from_uspace(istate, "Divide error.");
-
-	decode_istate(istate);
-	panic("Divide error.");
-}
-
 /** General Protection Fault. */
 static void gp_fault(int n __attribute__((unused)), istate_t *istate)
@@ -223,5 +215,4 @@
 	}
 	
-	exc_register(0, "de_fault", (iroutine) de_fault);
 	exc_register(7, "nm_fault", (iroutine) nm_fault);
 	exc_register(12, "ss_fault", (iroutine) ss_fault);
Index: kernel/arch/ia64/src/cpu/cpu.c
===================================================================
--- kernel/arch/ia64/src/cpu/cpu.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/ia64/src/cpu/cpu.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -37,5 +37,4 @@
 #include <arch/register.h>
 #include <print.h>
-#include <memstr.h>
 
 void cpu_arch_init(void)
Index: kernel/arch/mips32/include/mm/page.h
===================================================================
--- kernel/arch/mips32/include/mm/page.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/mips32/include/mm/page.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -141,19 +141,5 @@
 #include <arch/exception.h>
 
-/** Page Table Entry. */
-typedef struct {
-	unsigned g : 1;			/**< Global bit. */
-	unsigned p : 1;			/**< Present bit. */
-	unsigned d : 1;			/**< Dirty bit. */
-	unsigned cacheable : 1;		/**< Cacheable bit. */
-	unsigned : 1;			/**< Unused. */
-	unsigned soft_valid : 1;	/**< Valid content even if not present. */
-	unsigned pfn : 24;		/**< Physical frame number. */
-	unsigned w : 1;			/**< Page writable bit. */
-	unsigned a : 1;			/**< Accessed bit. */
-} pte_t;
-
-
-static inline unsigned int get_pt_flags(pte_t *pt, size_t i)
+static inline int get_pt_flags(pte_t *pt, size_t i)
 {
 	pte_t *p = &pt[i];
Index: kernel/arch/mips32/include/types.h
===================================================================
--- kernel/arch/mips32/include/types.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/mips32/include/types.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -80,4 +80,17 @@
 #define PRIxn "x"	/**< Format for hexadecimal (u)native_t. */
 
+/** Page Table Entry. */
+typedef struct {
+	unsigned g : 1;			/**< Global bit. */
+	unsigned p : 1;			/**< Present bit. */
+	unsigned d : 1;			/**< Dirty bit. */
+	unsigned cacheable : 1;		/**< Cacheable bit. */
+	unsigned : 1;			/**< Unused. */
+	unsigned soft_valid : 1;	/**< Valid content even if not present. */
+	unsigned pfn : 24;		/**< Physical frame number. */
+	unsigned w : 1;			/**< Page writable bit. */
+	unsigned a : 1;			/**< Accessed bit. */
+} pte_t;
+
 #endif
 
Index: kernel/arch/ppc32/include/mm/page.h
===================================================================
--- kernel/arch/ppc32/include/mm/page.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/ppc32/include/mm/page.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -131,16 +131,5 @@
 #include <arch/interrupt.h>
 
-/** Page Table Entry. */
-typedef struct {
-	unsigned present : 1;             /**< Present bit. */
-	unsigned page_write_through : 1;  /**< Write thought caching. */
-	unsigned page_cache_disable : 1;  /**< No caching. */
-	unsigned accessed : 1;            /**< Accessed bit. */
-	unsigned global : 1;              /**< Global bit. */
-	unsigned valid : 1;               /**< Valid content even if not present. */
-	unsigned pfn : 20;                /**< Physical frame number. */
-} pte_t;
-
-static inline unsigned int get_pt_flags(pte_t *pt, size_t i)
+static inline int get_pt_flags(pte_t *pt, size_t i)
 {
 	pte_t *p = &pt[i];
Index: kernel/arch/ppc32/include/types.h
===================================================================
--- kernel/arch/ppc32/include/types.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/ppc32/include/types.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -82,4 +82,15 @@
 #define PRIxn "x"
 
+/** Page Table Entry. */
+typedef struct {
+	unsigned present : 1;             /**< Present bit. */
+	unsigned page_write_through : 1;  /**< Write thought caching. */
+	unsigned page_cache_disable : 1;  /**< No caching. */
+	unsigned accessed : 1;            /**< Accessed bit. */
+	unsigned global : 1;              /**< Global bit. */
+	unsigned valid : 1;               /**< Valid content even if not present. */
+	unsigned pfn : 20;                /**< Physical frame number. */
+} pte_t;
+
 #endif
 
Index: kernel/arch/ppc32/src/mm/as.c
===================================================================
--- kernel/arch/ppc32/src/mm/as.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/ppc32/src/mm/as.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -35,5 +35,4 @@
 #include <arch/mm/as.h>
 #include <genarch/mm/as_pt.h>
-#include <genarch/mm/page_pt.h>
 #include <genarch/mm/asid_fifo.h>
 #include <arch.h>
Index: kernel/arch/ppc32/src/mm/tlb.c
===================================================================
--- kernel/arch/ppc32/src/mm/tlb.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/ppc32/src/mm/tlb.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -38,5 +38,4 @@
 #include <interrupt.h>
 #include <mm/as.h>
-#include <mm/page.h>
 #include <arch.h>
 #include <print.h>
Index: kernel/arch/ppc32/src/ppc32.c
===================================================================
--- kernel/arch/ppc32/src/ppc32.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/ppc32/src/ppc32.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -44,5 +44,4 @@
 #include <genarch/ofw/pci.h>
 #include <userspace.h>
-#include <mm/page.h>
 #include <proc/uarg.h>
 #include <console/console.h>
Index: kernel/arch/sparc64/src/mm/tlb.c
===================================================================
--- kernel/arch/sparc64/src/mm/tlb.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/sparc64/src/mm/tlb.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -37,5 +37,4 @@
 #include <mm/as.h>
 #include <mm/asid.h>
-#include <genarch/mm/page_ht.h>
 #include <arch/mm/frame.h>
 #include <arch/mm/page.h>
Index: kernel/genarch/include/mm/as_pt.h
===================================================================
--- kernel/genarch/include/mm/as_pt.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/genarch/include/mm/as_pt.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -36,5 +36,6 @@
 #define KERN_AS_PT_H_
 
-#include <arch/mm/page.h>
+#include <mm/mm.h>
+#include <arch/types.h>
 
 #define AS_PAGE_TABLE
Index: kernel/genarch/include/mm/page_pt.h
===================================================================
--- kernel/genarch/include/mm/page_pt.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/genarch/include/mm/page_pt.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -44,8 +44,7 @@
 #define KERN_PAGE_PT_H_
 
+#include <arch/types.h>
 #include <mm/as.h>
 #include <mm/page.h>
-#include <arch/mm/page.h>
-#include <arch/types.h>
 
 /*
Index: kernel/genarch/src/drivers/via-cuda/cuda.c
===================================================================
--- kernel/genarch/src/drivers/via-cuda/cuda.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/genarch/src/drivers/via-cuda/cuda.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -41,5 +41,4 @@
 #include <ddi/device.h>
 #include <synch/spinlock.h>
-#include <memstr.h>
 
 static irq_ownership_t cuda_claim(irq_t *irq);
Index: kernel/genarch/src/fb/fb.c
===================================================================
--- kernel/genarch/src/fb/fb.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/genarch/src/fb/fb.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -41,5 +41,4 @@
 #include <console/console.h>
 #include <sysinfo/sysinfo.h>
-#include <mm/page.h>
 #include <mm/slab.h>
 #include <align.h>
Index: kernel/generic/include/arch.h
===================================================================
--- kernel/generic/include/arch.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/include/arch.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -39,5 +39,4 @@
 #include <proc/thread.h>
 #include <proc/task.h>
-#include <mm/as.h>
 
 #define DEFAULT_CONTEXT		0
Index: kernel/generic/include/ipc/ipc.h
===================================================================
--- kernel/generic/include/ipc/ipc.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/include/ipc/ipc.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -51,12 +51,14 @@
 /** This is answer to a call */
 #define IPC_CALL_ANSWERED	(1 << 0)
+/** This call will not be freed on error */
+#define IPC_CALL_STATIC_ALLOC	(1 << 1)
 /** Answer will not be passed to userspace, will be discarded */
-#define IPC_CALL_DISCARD_ANSWER (1 << 1)
+#define IPC_CALL_DISCARD_ANSWER	(1 << 2)
 /** Call was forwarded */
-#define IPC_CALL_FORWARDED	(1 << 2)
+#define IPC_CALL_FORWARDED	(1 << 3)
 /** Identify connect_me_to answer */
-#define IPC_CALL_CONN_ME_TO	(1 << 3)
+#define IPC_CALL_CONN_ME_TO	(1 << 4)
 /** Interrupt notification */
-#define IPC_CALL_NOTIF		(1 << 4)
+#define IPC_CALL_NOTIF		(1 << 5)
 
 /*
@@ -265,7 +267,4 @@
 	waitq_t wq;
 
-	/** Linkage for the list of task's synchronous answerboxes. */
-	link_t sync_box_link;
-
 	/** Phones connected to this answerbox. */
 	link_t connected_phones;
@@ -317,31 +316,25 @@
 } call_t;
 
-
-extern answerbox_t *ipc_phone_0;
-
-
 extern void ipc_init(void);
-
-extern call_t * ipc_call_alloc(int);
-extern void ipc_call_free(call_t *);
-
+extern call_t * ipc_wait_for_call(answerbox_t *, uint32_t, int);
+extern void ipc_answer(answerbox_t *, call_t *);
 extern int ipc_call(phone_t *, call_t *);
 extern int ipc_call_sync(phone_t *, call_t *);
-extern call_t * ipc_wait_for_call(answerbox_t *, uint32_t, int);
-extern int ipc_forward(call_t *, phone_t *, answerbox_t *, int);
-extern void ipc_answer(answerbox_t *, call_t *);
-
 extern void ipc_phone_init(phone_t *);
 extern void ipc_phone_connect(phone_t *, answerbox_t *);
+extern void ipc_call_free(call_t *);
+extern call_t * ipc_call_alloc(int);
+extern void ipc_answerbox_init(answerbox_t *, struct task *);
+extern void ipc_call_static_init(call_t *);
+extern void task_print_list(void);
+extern int ipc_forward(call_t *, phone_t *, answerbox_t *, int);
+extern void ipc_cleanup(void);
 extern int ipc_phone_hangup(phone_t *);
-
-extern void ipc_answerbox_init(answerbox_t *, struct task *);
-
-extern void ipc_cleanup(void);
 extern void ipc_backsend_err(phone_t *, call_t *, unative_t);
+extern void ipc_print_task(task_id_t);
 extern void ipc_answerbox_slam_phones(answerbox_t *, bool);
 extern void ipc_cleanup_call_list(link_t *);
 
-extern void ipc_print_task(task_id_t);
+extern answerbox_t *ipc_phone_0;
 
 #endif
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/include/proc/task.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -55,5 +55,4 @@
 #include <udebug/udebug.h>
 #include <ipc/kbox.h>
-#include <mm/as.h>
 
 #define TASK_NAME_BUFLEN	20
@@ -99,6 +98,4 @@
 	 */
 	atomic_t active_calls;
-	/** List of synchronous answerboxes. */
-	link_t sync_box_head;
 
 #ifdef CONFIG_UDEBUG
@@ -135,5 +132,4 @@
 extern int task_kill(task_id_t id);
 extern uint64_t task_get_accounting(task_t *t);
-extern void task_print_list(void);
 
 extern void cap_set(task_t *t, cap_t caps);
Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/include/proc/thread.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -225,33 +225,34 @@
 
 extern void thread_init(void);
-extern thread_t *thread_create(void (*)(void *), void *, task_t *, int, char *,
-    bool);
-extern void thread_attach(thread_t *, task_t *);
-extern void thread_ready(thread_t *);
+extern thread_t *thread_create(void (* func)(void *), void *arg, task_t *task,
+    int flags, char *name, bool uncounted);
+extern void thread_attach(thread_t *t, task_t *task);
+extern void thread_ready(thread_t *t);
 extern void thread_exit(void) __attribute__((noreturn));
 
 #ifndef thread_create_arch
-extern void thread_create_arch(thread_t *);
+extern void thread_create_arch(thread_t *t);
 #endif
 #ifndef thr_constructor_arch
-extern void thr_constructor_arch(thread_t *);
+extern void thr_constructor_arch(thread_t *t);
 #endif
 #ifndef thr_destructor_arch
-extern void thr_destructor_arch(thread_t *);
-#endif
-
-extern void thread_sleep(uint32_t);
-extern void thread_usleep(uint32_t);
+extern void thr_destructor_arch(thread_t *t);
+#endif
+
+extern void thread_sleep(uint32_t sec);
+extern void thread_usleep(uint32_t usec);
 
 #define thread_join(t) \
 	thread_join_timeout((t), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE)
-extern int thread_join_timeout(thread_t *, uint32_t, int);
-extern void thread_detach(thread_t *);
-
-extern void thread_register_call_me(void (*)(void *), void *);
+extern int thread_join_timeout(thread_t *t, uint32_t usec, int flags);
+extern void thread_detach(thread_t *t);
+
+extern void thread_register_call_me(void (* call_me)(void *),
+    void *call_me_with);
 extern void thread_print_list(void);
-extern void thread_destroy(thread_t *);
+extern void thread_destroy(thread_t *t);
 extern void thread_update_accounting(void);
-extern bool thread_exists(thread_t *);
+extern bool thread_exists(thread_t *t);
 
 /** Fpu context slab cache. */
@@ -259,9 +260,8 @@
 
 /* Thread syscall prototypes. */
-extern unative_t sys_thread_create(uspace_arg_t *, char *, size_t,
-    thread_id_t *);
-extern unative_t sys_thread_exit(int);
-extern unative_t sys_thread_get_id(thread_id_t *);
-extern unative_t sys_thread_usleep(uint32_t);
+extern unative_t sys_thread_create(uspace_arg_t *uspace_uarg,
+    char *uspace_name, size_t name_len, thread_id_t *uspace_thread_id);
+extern unative_t sys_thread_exit(int uspace_status);
+extern unative_t sys_thread_get_id(thread_id_t *uspace_thread_id);
 
 #endif
Index: kernel/generic/include/string.h
===================================================================
--- kernel/generic/include/string.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/include/string.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -87,5 +87,5 @@
 extern void str_cpy(char *dest, size_t size, const char *src);
 extern void str_ncpy(char *dest, size_t size, const char *src, size_t n);
-extern void wstr_to_str(char *dest, size_t size, const wchar_t *src);
+extern void wstr_nstr(char *dst, const wchar_t *src, size_t size);
 
 extern char *str_chr(const char *str, wchar_t ch);
Index: kernel/generic/include/synch/futex.h
===================================================================
--- kernel/generic/include/synch/futex.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/include/synch/futex.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -38,4 +38,6 @@
 #include <arch/types.h>
 #include <synch/waitq.h>
+#include <genarch/mm/page_ht.h>
+#include <genarch/mm/page_pt.h>
 
 /** Kernel-side futex structure. */
@@ -52,6 +54,7 @@
 
 extern void futex_init(void);
-extern unative_t sys_futex_sleep(uintptr_t);
-extern unative_t sys_futex_wakeup(uintptr_t);
+extern unative_t sys_futex_sleep_timeout(uintptr_t uaddr, uint32_t usec,
+    int flags);
+extern unative_t sys_futex_wakeup(uintptr_t uaddr);
 
 extern void futex_cleanup(void);
Index: kernel/generic/include/syscall/syscall.h
===================================================================
--- kernel/generic/include/syscall/syscall.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/include/syscall/syscall.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -43,5 +43,4 @@
 	SYS_THREAD_EXIT,
 	SYS_THREAD_GET_ID,
-	SYS_THREAD_USLEEP,
 	
 	SYS_TASK_GET_ID,
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/src/console/console.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -319,15 +319,15 @@
 	
 	if (size > PAGE_SIZE)
-		return (unative_t) ELIMIT;
+		return ELIMIT;
 	
 	if (size > 0) {
 		data = (char *) malloc(size + 1, 0);
 		if (!data)
-			return (unative_t) ENOMEM;
+			return ENOMEM;
 		
 		rc = copy_from_uspace(data, buf, size);
 		if (rc) {
 			free(data);
-			return (unative_t) rc;
+			return rc;
 		}
 		data[size] = 0;
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/src/console/kconsole.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -289,5 +289,5 @@
 			
 			char tmp[STR_BOUNDS(MAX_CMDLINE)];
-			wstr_to_str(tmp, position - beg + 1, current + beg);
+			wstr_nstr(tmp, current + beg, position - beg + 1);
 			
 			int found;
@@ -665,5 +665,5 @@
 		
 		char cmdline[STR_BOUNDS(MAX_CMDLINE)];
-		wstr_to_str(cmdline, STR_BOUNDS(MAX_CMDLINE), tmp);
+		wstr_nstr(cmdline, tmp, STR_BOUNDS(MAX_CMDLINE));
 		
 		if ((!kcon) && (len == 4) && (str_lcmp(cmdline, "exit", 4) == 0))
Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/src/ipc/ipc.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -62,5 +62,4 @@
 
 static slab_cache_t *ipc_call_slab;
-static slab_cache_t *ipc_answerbox_slab;
 
 /** Initialize a call structure.
@@ -97,4 +96,15 @@
 }
 
+/** Initialize a statically allocated call structure.
+ *
+ * @param call		Statically allocated kernel call structure to be
+ *			initialized.
+ */
+void ipc_call_static_init(call_t *call)
+{
+	_ipc_call_init(call);
+	call->flags |= IPC_CALL_STATIC_ALLOC;
+}
+
 /** Deallocate a call structure.
  *
@@ -103,4 +113,5 @@
 void ipc_call_free(call_t *call)
 {
+	ASSERT(!(call->flags & IPC_CALL_STATIC_ALLOC));
 	/* Check to see if we have data in the IPC_M_DATA_SEND buffer. */
 	if (call->buffer)
@@ -119,5 +130,4 @@
 	spinlock_initialize(&box->irq_lock, "ipc_box_irqlock");
 	waitq_initialize(&box->wq);
-	link_initialize(&box->sync_box_link);
 	list_initialize(&box->connected_phones);
 	list_initialize(&box->calls);
@@ -169,41 +179,15 @@
 int ipc_call_sync(phone_t *phone, call_t *request)
 {
-	answerbox_t *sync_box; 
-	ipl_t ipl;
-
-	sync_box = slab_alloc(ipc_answerbox_slab, 0);
-	ipc_answerbox_init(sync_box, TASK);
-
-	/*
-	 * Put the answerbox on the TASK's list of synchronous answerboxes so
-	 * that it can be cleaned up if the call is interrupted.
-	 */
-	ipl = interrupts_disable();
-	spinlock_lock(&TASK->lock);
-	list_append(&sync_box->sync_box_link, &TASK->sync_box_head);
-	spinlock_unlock(&TASK->lock);
-	interrupts_restore(ipl);
+	answerbox_t sync_box; 
+
+	ipc_answerbox_init(&sync_box, TASK);
 
 	/* We will receive data in a special box. */
-	request->callerbox = sync_box;
+	request->callerbox = &sync_box;
 
 	ipc_call(phone, request);
-	if (!ipc_wait_for_call(sync_box, SYNCH_NO_TIMEOUT,
-	    SYNCH_FLAGS_INTERRUPTIBLE)) {
-	    	/* The answerbox and the call will be freed by ipc_cleanup(). */
+	if (!ipc_wait_for_call(&sync_box, SYNCH_NO_TIMEOUT,
+	    SYNCH_FLAGS_INTERRUPTIBLE))
 		return EINTR;
-	}
-
-	/*
-	 * The answer arrived without interruption so we can remove the
-	 * answerbox from the TASK's list of synchronous answerboxes.
-	 */
-	(void) interrupts_disable();
-	spinlock_lock(&TASK->lock);
-	list_remove(&sync_box->sync_box_link);
-	spinlock_unlock(&TASK->lock);
-	interrupts_restore(ipl);
-
-	slab_free(ipc_answerbox_slab, sync_box);
 	return EOK;
 }
@@ -536,5 +520,4 @@
 	int i;
 	call_t *call;
-	ipl_t ipl;
 
 	/* Disconnect all our phones ('ipc_phone_hangup') */
@@ -562,19 +545,5 @@
 	spinlock_unlock(&TASK->answerbox.lock);
 	
-	/* Wait for all answers to interrupted synchronous calls to arrive */
-	ipl = interrupts_disable();
-	while (!list_empty(&TASK->sync_box_head)) {
-		answerbox_t *box = list_get_instance(TASK->sync_box_head.next,
-		    answerbox_t, sync_box_link);
-
-		list_remove(&box->sync_box_link);
-		call = ipc_wait_for_call(box, SYNCH_NO_TIMEOUT,
-		    SYNCH_FLAGS_NONE);
-		ipc_call_free(call);
-		slab_free(ipc_answerbox_slab, box);
-	}
-	interrupts_restore(ipl);
-
-	/* Wait for all answers to asynchronous calls to arrive */
+	/* Wait for all async answers to arrive */
 	while (1) {
 		/* Go through all phones, until all are FREE... */
@@ -583,8 +552,6 @@
 		for (i = 0; i < IPC_MAX_PHONES; i++) {
 			if (TASK->phones[i].state == IPC_PHONE_HUNGUP &&
-			    atomic_get(&TASK->phones[i].active_calls) == 0) {
+			    atomic_get(&TASK->phones[i].active_calls) == 0)
 				TASK->phones[i].state = IPC_PHONE_FREE;
-				TASK->phones[i].callee = NULL;
-			}
 			
 			/* Just for sure, we might have had some 
@@ -607,4 +574,5 @@
 		ASSERT((call->flags & IPC_CALL_ANSWERED) ||
 		    (call->flags & IPC_CALL_NOTIF));
+		ASSERT(!(call->flags & IPC_CALL_STATIC_ALLOC));
 		
 		/*
@@ -625,6 +593,4 @@
 	ipc_call_slab = slab_cache_create("ipc_call", sizeof(call_t), 0, NULL,
 	    NULL, 0);
-	ipc_answerbox_slab = slab_cache_create("ipc_answerbox",
-	    sizeof(answerbox_t), 0, NULL, NULL, 0);
 }
 
Index: kernel/generic/src/ipc/irq.c
===================================================================
--- kernel/generic/src/ipc/irq.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/src/ipc/irq.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -418,4 +418,5 @@
 		case CMD_ACCEPT:
 			return IRQ_ACCEPT;
+			break;
 		case CMD_DECLINE:
 		default:
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/src/ipc/sysipc.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -61,5 +61,5 @@
 { \
 	if (phoneid > IPC_MAX_PHONES) { \
-		err \
+		err; \
 	} \
 	phone = &TASK->phones[phoneid]; \
@@ -122,4 +122,5 @@
 	case IPC_M_DATA_READ:
 		return 1;
+		break;
 	default:
 		return 0;
@@ -375,5 +376,5 @@
 		phone_t *cloned_phone;
 		GET_CHECK_PHONE(cloned_phone, IPC_GET_ARG1(call->data),
-		    return ENOENT;);
+		    return ENOENT);
 		phones_lock(cloned_phone, phone);
 		if ((cloned_phone->state != IPC_PHONE_CONNECTED) ||
@@ -530,42 +531,39 @@
     unative_t arg1, unative_t arg2, unative_t arg3, ipc_data_t *data)
 {
-	call_t *call;
+	call_t call;
 	phone_t *phone;
 	int res;
 	int rc;
 	
-	GET_CHECK_PHONE(phone, phoneid, return ENOENT;);
-
-	call = ipc_call_alloc(0);
-	IPC_SET_METHOD(call->data, method);
-	IPC_SET_ARG1(call->data, arg1);
-	IPC_SET_ARG2(call->data, arg2);
-	IPC_SET_ARG3(call->data, arg3);
+	GET_CHECK_PHONE(phone, phoneid, return ENOENT);
+
+	ipc_call_static_init(&call);
+	IPC_SET_METHOD(call.data, method);
+	IPC_SET_ARG1(call.data, arg1);
+	IPC_SET_ARG2(call.data, arg2);
+	IPC_SET_ARG3(call.data, arg3);
 	/*
 	 * To achieve deterministic behavior, zero out arguments that are beyond
 	 * the limits of the fast version.
 	 */
-	IPC_SET_ARG4(call->data, 0);
-	IPC_SET_ARG5(call->data, 0);
-
-	if (!(res = request_preprocess(call, phone))) {
+	IPC_SET_ARG4(call.data, 0);
+	IPC_SET_ARG5(call.data, 0);
+
+	if (!(res = request_preprocess(&call, phone))) {
 #ifdef CONFIG_UDEBUG
 		udebug_stoppable_begin();
 #endif
-		rc = ipc_call_sync(phone, call);
+		rc = ipc_call_sync(phone, &call);
 #ifdef CONFIG_UDEBUG
 		udebug_stoppable_end();
 #endif
-		if (rc != EOK) {
-			/* The call will be freed by ipc_cleanup(). */
+		if (rc != EOK)
 			return rc;
-		}
-		process_answer(call);
+		process_answer(&call);
 
 	} else {
-		IPC_SET_RETVAL(call->data, res);
-	}
-	rc = STRUCT_TO_USPACE(&data->args, &call->data.args);
-	ipc_call_free(call);
+		IPC_SET_RETVAL(call.data, res);
+	}
+	rc = STRUCT_TO_USPACE(&data->args, &call.data.args);
 	if (rc != 0)
 		return rc;
@@ -586,38 +584,32 @@
     ipc_data_t *reply)
 {
-	call_t *call;
+	call_t call;
 	phone_t *phone;
 	int res;
 	int rc;
 
-	GET_CHECK_PHONE(phone, phoneid, return ENOENT;);
-
-	call = ipc_call_alloc(0);
-	rc = copy_from_uspace(&call->data.args, &question->args,
-	    sizeof(call->data.args));
-	if (rc != 0) {
-		ipc_call_free(call);
+	ipc_call_static_init(&call);
+	rc = copy_from_uspace(&call.data.args, &question->args,
+	    sizeof(call.data.args));
+	if (rc != 0)
 		return (unative_t) rc;
-	}
-
-
-	if (!(res = request_preprocess(call, phone))) {
+
+	GET_CHECK_PHONE(phone, phoneid, return ENOENT);
+
+	if (!(res = request_preprocess(&call, phone))) {
 #ifdef CONFIG_UDEBUG
 		udebug_stoppable_begin();
 #endif
-		rc = ipc_call_sync(phone, call);
+		rc = ipc_call_sync(phone, &call);
 #ifdef CONFIG_UDEBUG
 		udebug_stoppable_end();
 #endif
-		if (rc != EOK) {
-			/* The call will be freed by ipc_cleanup(). */
+		if (rc != EOK)
 			return rc;
-		}
-		process_answer(call);
+		process_answer(&call);
 	} else 
-		IPC_SET_RETVAL(call->data, res);
-
-	rc = STRUCT_TO_USPACE(&reply->args, &call->data.args);
-	ipc_call_free(call);
+		IPC_SET_RETVAL(call.data, res);
+
+	rc = STRUCT_TO_USPACE(&reply->args, &call.data.args);
 	if (rc != 0)
 		return rc;
@@ -666,5 +658,5 @@
 		return IPC_CALLRET_TEMPORARY;
 
-	GET_CHECK_PHONE(phone, phoneid, return IPC_CALLRET_FATAL;);
+	GET_CHECK_PHONE(phone, phoneid, return IPC_CALLRET_FATAL);
 
 	call = ipc_call_alloc(0);
@@ -705,5 +697,5 @@
 		return IPC_CALLRET_TEMPORARY;
 
-	GET_CHECK_PHONE(phone, phoneid, return IPC_CALLRET_FATAL;);
+	GET_CHECK_PHONE(phone, phoneid, return IPC_CALLRET_FATAL);
 
 	call = ipc_call_alloc(0);
@@ -755,5 +747,5 @@
 	call->flags |= IPC_CALL_FORWARDED;
 
-	GET_CHECK_PHONE(phone, phoneid, {
+	GET_CHECK_PHONE(phone, phoneid, { 
 		IPC_SET_RETVAL(call->data, EFORWARD);
 		ipc_answer(&TASK->answerbox, call);
@@ -960,5 +952,5 @@
 	phone_t *phone;
 
-	GET_CHECK_PHONE(phone, phoneid, return ENOENT;);
+	GET_CHECK_PHONE(phone, phoneid, return ENOENT);
 
 	if (ipc_phone_hangup(phone))
@@ -999,4 +991,6 @@
 
 	if (call->flags & IPC_CALL_NOTIF) {
+		ASSERT(! (call->flags & IPC_CALL_STATIC_ALLOC));
+
 		/* Set in_phone_hash to the interrupt counter */
 		call->data.phone = (void *) call->priv;
@@ -1011,4 +1005,6 @@
 	if (call->flags & IPC_CALL_ANSWERED) {
 		process_answer(call);
+
+		ASSERT(! (call->flags & IPC_CALL_STATIC_ALLOC));
 
 		if (call->flags & IPC_CALL_DISCARD_ANSWER) {
Index: kernel/generic/src/lib/elf.c
===================================================================
--- kernel/generic/src/lib/elf.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/generic/src/lib/elf.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -163,4 +163,5 @@
 	case PT_LOAD:
 		return load_segment(entry, elf, as);
+		break;
 	case PT_DYNAMIC:
 	case PT_INTERP:
@@ -181,4 +182,5 @@
 	default:
 		return EE_UNSUPPORTED;
+		break;
 	}
 	return EE_OK;
